/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _USERLIST_
#define _USERLIST_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qlistbox.h>
#include <qlist.h>
#include <kpopupmenu.h>
#include "useritem.h"
#include "blinklistbox.h"

class icqMessage;

class UserList : public QListBox {
  Q_OBJECT
public:
  UserList(QWidget *parent=0, const char *name=0, WFlags f=0);
  ~UserList(void);
  UserItem *getItem(int);
  UserItem *getCurrent(void);
  int allCheck(void);
  void allChange(void);
  void setAllOnline(bool);
  bool getAllOnline(void) const;
  void allOffline(void);
  void changeList(void);
  void setBlinkingByUIN(unsigned long,int) ;
  void setBlinkInterval(int);
  void setBlinking(UserItem*, int);
  int blinkItemsCount(void);
protected:
  QPopupMenu *debug;
  KPopupMenu *popup, *alertpopup, *specialoppopup;
  int oldCurrent;
  int doRemove;
  int recvRemove;
  int onlineID, visibleID;
  int allSetting;
  void paintCell(QPainter*, int, int);
  void mousePressEvent(QMouseEvent*);
  int getIndex(UserItem *bitem);
  int timerId;
  int blinkInterval;
  virtual void timerEvent(QTimerEvent*);
protected slots:
  void addRequest(void);
private:
  void CrashGuard(void);
};
#endif
