/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: alertbox.cpp,v 1.3 2000/10/14 21:00:50 davidvh Exp $
// $Log: alertbox.cpp,v $
// Revision 1.3  2000/10/14 21:00:50  davidvh
// Minor fixes.
//
// Revision 1.2  2000/09/13 19:11:12  napalmbox
// replase kicq ver 1.0.0 files with kicq ver 2.0.0 files
//
// Revision 1.1.2.1  2000/07/22 19:47:59  napalmbox
// kicq now compiles with -DQT_NO_ASCII_CAST
//
// Revision 1.1  2000/05/24 16:57:16  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.5  1999/12/02 13:56:39  denis
// Cleanups.
//
// Revision 1.4  1999/07/16 15:47:35  denis
// Cleaned up.
//
// Revision 1.3  1999/04/17 20:23:48  bills
// delete called in class instead of using auto-delete list for consistency
//
// Revision 1.2  1998/11/19 12:40:43  denis
// Default and Escape options added to Ok button
//

#include "alertbox.h"
#include "mainwindow.h"

#include "alertbox.moc"

AlertMsgBox::AlertMsgBox(unsigned long puin, const QString &caption, const QString &text) :
  QMessageBox(caption, text, QMessageBox::Information,
              QMessageBox::Ok | QMessageBox::Default | QMessageBox::Escape,
              0, 0, 0L, 0L, FALSE)
{
  auin = puin;
  setMinimumSize(200,100);
  return;
}

AlertMsgBox::~AlertMsgBox(void)
{
  auin = 0;
  return;
}

unsigned long AlertMsgBox::uin(void)
{
  return auin;
}

void AlertMsgBox::closeEvent(QCloseEvent *ce)
{
  QWidget::closeEvent(ce);
  MW->delAlertWin(this);
  delete this;
  return;
}

void AlertMsgBox::done(int)
{
  hide();
  MW->delAlertWin(this);
  delete this;
  return;
}
