//
// $Id: icqlibmanager.h,v 1.1 2001/02/22 06:01:40 bills Exp $
//
// Base manager class for icqlib sockets & timeouts.  Installs a handler 
// for icq_SocketNotify & icq_SetTimeout, and provides virtual functions 
// installSocketNotifier, removeSocketNotifier, and startTimeout for 
// subclasses to override.
//
// $Log: icqlibmanager.h,v $
// Revision 1.1  2001/02/22 06:01:40  bills
// added, supports sockets and timeouts
//
//
//
//

#ifndef _ICQLIBMANAGER_H
#define _ICQLIBMANAGER_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

class IcqlibManager {

public:
  IcqlibManager();
  
protected:
  virtual void installSocketNotifier(int socket, int type) = 0;
  virtual void removeSocketNotifier(int socket, int type) = 0;
  virtual void startTimeout(long seconds) = 0;

private:
  static void onSocketNotify(int socket, int type, int status);
  static void onSetTimeout(long seconds);

};

extern IcqlibManager *g_icqlibManager;

#endif // _ICQLIBMANAGER_H
