//
// $Id: kicqlibmanager.cpp,v 1.2 2001/03/03 20:20:19 bills Exp $
//
// $Log: kicqlibmanager.cpp,v $
// Revision 1.2  2001/03/03 20:20:19  bills
// icq_SetTimeout(0) now stops timer
//
// Revision 1.1  2001/02/22 06:01:40  bills
// added, supports sockets and timeouts
//
//
//

#include <icq.h>

#include "kicqlibmanager.h"

#include "kicqlibmanager.moc"

KICQLibManager::KICQLibManager()
{
  readSocketNotifiers.setAutoDelete(true);
  writeSocketNotifiers.setAutoDelete(true);
  connect(&timer, SIGNAL(timeout()), SLOT(timeout()));
}

void KICQLibManager::installSocketNotifier(int socket, int type)
{
  QSocketNotifier *qsn;

  switch(type)
  {
    case ICQ_SOCKET_READ:
      qsn = new QSocketNotifier(socket, QSocketNotifier::Read);
      connect(qsn, SIGNAL(activated(int)), SLOT(socketReadReady(int)));
      readSocketNotifiers.insert(socket, qsn);
      break;
    case ICQ_SOCKET_WRITE:
      qsn = new QSocketNotifier(socket, QSocketNotifier::Write);
      connect(qsn, SIGNAL(activated(int)), SLOT(socketWriteReady(int)));
      writeSocketNotifiers.insert(socket, qsn);
      break;
    default:
      break;
  }     
}

void KICQLibManager::removeSocketNotifier(int socket, int type)
{
  switch(type)
  {
    case ICQ_SOCKET_READ:
      readSocketNotifiers.remove(socket);
      break;
    case ICQ_SOCKET_WRITE:
      writeSocketNotifiers.remove(socket);
      break;
    default:
      break;
  }
}

void KICQLibManager::startTimeout(long seconds)
{
  if (seconds)
    timer.start(seconds * 1000, true);
  else
    timer.stop();
}

void KICQLibManager::socketReadReady(int socket)
{
  icq_HandleReadySocket(socket, ICQ_SOCKET_READ);
}

void KICQLibManager::socketWriteReady(int socket)
{
  icq_HandleReadySocket(socket, ICQ_SOCKET_WRITE);
}

void KICQLibManager::timeout()
{
  icq_HandleTimeout();
}

