/***************************************************************************
    description          : infowork.cpp
    begin                : Wed Apr 12 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@icqmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qbuttongroup.h>
#include "infowork.h"
#include "mainwindow.h"
#include "corewidget.h"
#include "mydetailspics.h"

#include "infowork.moc"

WorkWidget::WorkWidget(QWidget *parent) : QWidget(parent)
{

  nbox = new QButtonGroup(this);
  nbox->setGeometry(2, 6, 202, 122);
  nbox->setFrameStyle(QFrame::Box | QFrame::Sunken);
  nbox->setTitle(i18n("Company"));

  nlebel = new QLabel(i18n("Name:"),nbox);
  nlebel->setGeometry(10, 16, 43, 20);
  nlebel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  nlebel->setFrameStyle(QFrame::NoFrame);
  nlebel->setAlignment(AlignLeft | AlignVCenter);

  olabel = new QLabel(i18n("Occupation:"),nbox);
  olabel->setGeometry(10, 94, 80, 20);
  olabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  olabel->setFrameStyle(QFrame::NoFrame);
  olabel->setAlignment(AlignLeft | AlignVCenter);

  plabel = new QLabel(i18n("Position:"),nbox);
  plabel->setGeometry(10, 68, 61, 20);
  plabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  plabel->setFrameStyle(QFrame::NoFrame);
  plabel->setAlignment(AlignLeft | AlignVCenter);

  dlabel = new QLabel(i18n("Div/Dept:"),nbox);
  dlabel->setGeometry(10, 43, 56, 20);
  dlabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  dlabel->setFrameStyle(QFrame::NoFrame);
  dlabel->setAlignment(AlignLeft | AlignVCenter);

  oline = new ULine(nbox, true);
  oline->setGeometry(83, 94, 110, 20);

  pline = new ULine(nbox, true);
  pline->setGeometry(83, 68, 110, 20);

  dline = new ULine(nbox, true);
  dline->setGeometry(83, 42, 110, 20);

  nline = new ULine(nbox, true);
  nline->setGeometry(83, 16, 110, 20);
//////////////////////////////////////////////////////////////////////////////////////////////////
  phbox = new QButtonGroup(this);
  phbox->setGeometry(208, 6, 198, 122);
  phbox->setFrameStyle(QFrame::Box | QFrame::Sunken);
  phbox->setTitle(i18n("Phone Directory"));

  phlabel = new QLabel(i18n("Phone:"),phbox);
  phlabel->setGeometry(10, 16, 45, 20);
  phlabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  phlabel->setFrameStyle(QFrame::NoFrame);
  phlabel->setAlignment(AlignLeft | AlignVCenter);

  flabel = new QLabel(i18n("Fax:"),phbox);
  flabel->setGeometry(10, 43, 36, 20);
  flabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  flabel->setFrameStyle(QFrame::NoFrame);
  flabel->setAlignment(AlignLeft | AlignVCenter);

  pline = new ULine(phbox, true);
  pline->setGeometry(54, 16, 110, 20);

  phico = new QLabel(phbox);
  phico->setGeometry(170, 16, 20, 20);
  phico->setFrameStyle(QFrame::NoFrame);
  phico->setPixmap(QPixmap(ph_xpm));
  phico->setAlignment(AlignHCenter | AlignVCenter);

  faxico = new QLabel(phbox);
  faxico->setGeometry(170, 43, 20, 20);
  faxico->setFrameStyle(QFrame::NoFrame);
  faxico->setPixmap(QPixmap(fax_xpm));
  faxico->setAlignment(AlignHCenter | AlignVCenter);

  fline = new ULine(phbox, true);
  fline->setGeometry(54, 43, 110, 20);

/////////////////////////////////////////////////////////////////////////////////////////////////
  addbox = new QButtonGroup(this);
  addbox->setGeometry(2, 128, 404, 124);
  addbox->setFrameStyle(QFrame::Box | QFrame::Sunken);
  addbox->setTitle(i18n("Work Address"));

  ssll = new QLabel(i18n("Street"),addbox);
  ssll->setGeometry(10, 16, 40, 20);
  ssll->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  ssll->setFrameStyle(QFrame::NoFrame);
  ssll->setAlignment(AlignLeft | AlignVCenter);

  addll = new QLabel(i18n("Address:"),addbox);
  addll->setGeometry(10, 33, 52, 20);
  addll->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  addll->setFrameStyle(QFrame::NoFrame);
  addll->setAlignment(AlignLeft | AlignTop);

  citylabel = new QLabel(i18n("City:"),addbox);
  citylabel->setGeometry(205, 16, 31, 20);
  citylabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  citylabel->setFrameStyle(QFrame::NoFrame);
  citylabel->setAlignment(AlignLeft | AlignVCenter);

  statelabel = new QLabel(i18n("State:"),addbox);
  statelabel->setGeometry(205, 43, 43, 20);
  statelabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  statelabel->setFrameStyle(QFrame::NoFrame);
  statelabel->setAlignment(AlignLeft | AlignVCenter);

  cityline = new ULine(addbox, true);
  cityline->setGeometry(264, 16, 130, 20);

  stateline = new ULine(addbox, true);
  stateline->setGeometry(264, 43, 130, 20);
  stateline->setMaxLength(32767);

  ziplabel = new QLabel(i18n("Zip Code:"),addbox);
  ziplabel->setGeometry(205, 70, 57, 20);
  ziplabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  ziplabel->setFrameStyle(QFrame::NoFrame);
  ziplabel->setAlignment(AlignLeft | AlignVCenter);

  zipline = new ULine(addbox, true);
  zipline->setGeometry(264, 70, 130, 20);

  cclabel = new QLabel(i18n("Country:"),addbox);
  cclabel->setGeometry(205, 98, 59, 19);
  cclabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  cclabel->setFrameStyle(QFrame::NoFrame);
  cclabel->setAlignment(AlignLeft | AlignVCenter);

  ccline = new ULine(addbox, true);
  ccline->setGeometry(264, 98, 130, 20);

  addmultyline = new MLine(addbox, true);
  addmultyline->setGeometry(66, 16, 130, 49);
  addmultyline->setFrameStyle(QFrame::Panel | QFrame::Sunken);

  ppll = new QLabel(i18n("Page:"),addbox);
  ppll->setGeometry(10, 98, 39, 20);
  ppll->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  ppll->setFrameStyle(QFrame::NoFrame);
  ppll->setAlignment(AlignLeft | AlignVCenter);

  dspmapbut = new QPushButton(addbox);
  dspmapbut->setGeometry(66, 70, 130, 20);
  dspmapbut->setText(i18n("Display Map"));

  homepico = new QLabel(addbox);
  homepico->setGeometry(174, 98, 20, 20);
  homepico->setFrameStyle(QFrame::NoFrame);
  homepico->setPixmap(QPixmap(home_xpm));
  homepico->setAlignment(AlignHCenter | AlignVCenter);

  homepline = new ULine(addbox, true);
  homepline->setGeometry(66, 98, 104, 20);

  hhll = new QLabel(i18n("Home"),addbox);
  hhll->setGeometry(10, 80, 39, 20);
  hhll->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  hhll->setFrameStyle(QFrame::NoFrame);
  hhll->setAlignment(AlignLeft | AlignBottom);

}


