/***************************************************************************
    description          : mainmenus.cpp
    begin                : Tue Sep 19 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "mainwindow.h"
#include "specialops.h"
#include "pref_main.h"
#include "icqanimbutton.h"
#include "corewidget.h"

void MainWindow::initMainMenus(void)
{
  statemenu = new QPopupMenu();
  statemenu->insertItem(UserIcon("conline"),i18n("Online/Connect"),stOnline);
  statemenu->insertItem(UserIcon("caway"),i18n("Away"),stAway);
  statemenu->insertItem(UserIcon("cna"),i18n("N/A (Extended Away)"),stNA);
  statemenu->insertItem(UserIcon("coccupied"),i18n("Occupied (Urgent Msgs)"),stOccupied);
  statemenu->insertItem(UserIcon("cdnd"),i18n("DND (Do not Disturb)"),stDND);
  statemenu->insertItem(UserIcon("cprivacy"),i18n("Privacy (Invisible)"),stInvisible);
  statemenu->insertItem(UserIcon("cfreechat"),i18n("Free for Chat"),stFFC);
  statemenu->insertItem(UserIcon("coffline"),i18n("Offline/Disconnect"),stOffline);
  statemenu->setMouseTracking(TRUE);

  connect(statemenu, SIGNAL(activated(int)), this, SLOT(setStatus(int)));
  connect(allbutton, SIGNAL(clicked()), SLOT(allCommand()));
  connect(addbutton, SIGNAL(clicked()),this, SLOT(addCommand()));
  connect(menubutton, SIGNAL(clicked()), SLOT(menuCommand()));
  connect(statebutton, SIGNAL(clicked()), SLOT(stateCommand()));

  ownersmenu = new QPopupMenu();

  myicqmenu = new QPopupMenu();
  myicqmenu->insertItem(UserIcon("quick"), i18n("Hide / Show QuickBar"), 0);
  myicqmenu->setItemEnabled(0, FALSE);
  myicqmenu->insertItem(UserIcon("newowner"), i18n("Add / Register UIN"),this, SLOT(registerCommand()));
  myicqmenu->insertItem(UserIcon("owneruin"), i18n("Change Owner UIN"), ownersmenu);

  icqmenu = new QPopupMenu();
  icqmenu->insertItem(UserIcon("search"), i18n("Add / Invite Users"),this,SLOT(addCommand()));
  icqmenu->insertSeparator();
  icqmenu->insertItem(UserIcon("info2"), i18n("View / Change My Details"),this,SLOT(myDetails()));
  icqmenu->insertItem(UserIcon("setup"), i18n("Preferences"),MENU_PREFERENCES);
  icqmenu->insertItem(UserIcon("key"), i18n("Security & Privacy"),MENU_SECURITY);
  icqmenu->setItemEnabled(MENU_SECURITY, FALSE);
  icqmenu->insertItem(UserIcon("myicq"), i18n("My Icq"), myicqmenu);
  icqmenu->insertSeparator();
  icqmenu->insertItem(UserIcon("help"), i18n("Help"),helpMenu(QString::null, false));
  icqmenu->insertSeparator();
  icqmenu->insertItem(UserIcon("shutdown"), i18n("Shut Down"),MENU_SHUTDOWN);

  icqmenu->setMouseTracking(TRUE);

  connect(icqmenu, SIGNAL(activated(int)),this, SLOT(icqCommand(int)));
  return;
}

void MainWindow::destroyMainMenus(void)
{
  RemovePopup(icqmenu);
  RemovePopup(myicqmenu);
  RemovePopup(ownersmenu);
  RemovePopup(statemenu);
  return;
}

void MainWindow::clearMainMenus(void)
{
  statemenu = 0;
  ownersmenu = 0;
  myicqmenu = 0;
  icqmenu = 0;
  return;
}

void MainWindow::menuCommand(void)
{
  QPoint p = menubutton->mapToGlobal(QPoint(0, 0));
  QSize s(icqmenu->sizeHint());
  p.setY(p.y()-s.height());
  icqmenu->exec(p);
  return;
}

void MainWindow::stateCommand(void)
{
  QPoint p = statebutton->mapToGlobal(QPoint(0, 0));
  QSize s(statemenu->sizeHint());
  p.setY(p.y()-s.height());
  statemenu->exec(p);
  return;
}

void MainWindow::icqCommand(int num)
{
  QString s = i18n("Preferences For Owner: ");
  s += nick;
  QString temp;
  switch(num)
  {
  case MENU_SHUTDOWN:
    quitRequest();
    break;
  case MENU_PREFERENCES:
    prefwin->setOwner(uin,nick,passwd);
    prefwin->setServer(server,port);
    prefwin->setProxy(useproxy, proxyhost, proxyport, proxyauth, proxyuser, proxypass);
    prefwin->setLogging(icq_LogLevel, logfile);
    prefwin->setSound(playWav);
    prefwin->setOther(icq_Russian, closeRecv, convertCRLF, quote, reconnect);
    prefwin->setAway(autoawaytimeout, autonatimeout, autoawayenabled, autoawaytona);
    prefwin->setCaption(s);
    if(prefwin->exec()==QDialog::Accepted)
    {
      loadConfig();
      setTitle();
    }
    break;
  case MENU_SECURITY:
    break;
  }
  return;
}
