/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 * File: specialops.cpp
 *
 * Created: Fri May 26 15:00:44 2000
 *
 * $Id: specialops.cpp,v 1.3 2000/10/02 07:37:47 denis Exp $
 */

#include <stdlib.h>
#include "mainwindow.h"
#include "kwebbrowser.h"
#include "userlist.h"
#include "specialops.h"

void MainWindow::mailRequest(QString address)
{
  if(!address.isEmpty())
    KWebBrowser::callWebBrowser(QString("mailto:") + address);
  else
    QMessageBox::warning(this, i18n("Error"), i18n("This user has not entered his e-mail address!"));
  return;
}

void MainWindow::mailRequest(void)
{
  if(listwidget->currentItem() < 0)
    return;
  unsigned long uin = listwidget->getCurrent()->getUIN();
  mailRequest(contactList().getEMailByUIN(uin));
  return;
}

void MainWindow::specialOpRequest(int op)
{
  if(listwidget->currentItem() < 0)
    return;
  unsigned long ip = contactList().getLastIPByUIN(listwidget->getCurrent()->getUIN());
  if(ip == 0)
    QMessageBox::warning(this, i18n("Error"), i18n("Cannot determine IP of this user!"));
  else
    switch(op)
    {
      case KICQ_SPECIALOPS_CONNECT_TO_FTP_SERVER:
        webBrowserRequest(-1, "ftp://");
        break;
      case KICQ_SPECIALOPS_CONNECT_TO_HTTP_SERVER:
        webBrowserRequest(-1, "http://");
        break;
      case KICQ_SPECIALOPS_CONNECT_TO_TETRINET_SERVER:
        tetrinetRequest(-1);
        break;
      case KICQ_SPECIALOPS_TELNET:
        telnetRequest(-1);
        break;
      case KICQ_SPECIALOPS_PING:
        pingRequest(-1);
        break;
      case KICQ_SPECIALOPS_TRACEROUTE:
        tracerouteRequest(-1); 
        break;
      default:
        break;
    }
  return;
}

void MainWindow::webBrowserRequest(QString url)
{
  KWebBrowser::callWebBrowser(url); 
  return;
}

void MainWindow::webBrowserRequest(int userNumber, QString protocol)
{
  if(listwidget->currentItem() < 0)
    return;
  unsigned long ip = contactList().getLastIPByUIN(listwidget->getCurrent()->getUIN());
  webBrowserRequest(protocol + intIP2StringIP(ip));
  return;
}

void MainWindow::tetrinetRequest(QString ip)
{
//  system("gtetrinet " + ip.latin1() + " &");
  return;
}

void MainWindow::tetrinetRequest(int userNumber)
{
  if(listwidget->currentItem() < 0)
    return;
  unsigned long ip = contactList().getLastIPByUIN(listwidget->getCurrent()->getUIN());
  tetrinetRequest(intIP2StringIP(ip));
  return;
}

void MainWindow::telnetRequest(QString ip)
{
//  system(QString("konsole -e bash -c \"telnet ") + ip + "; read\" &");
  return;
}

void MainWindow::telnetRequest(int userNumber)
{
  if(listwidget->currentItem() < 0)
    return;
  unsigned long ip = contactList().getLastIPByUIN(listwidget->getCurrent()->getUIN());
  telnetRequest(intIP2StringIP(ip));
  return;
}

void MainWindow::pingRequest(QString ip)
{
 // system(QString("xterm -e bash -c \"ping ") + ip + "; read\" &");
  return;
}

void MainWindow::pingRequest(int userNumber)
{
  if(listwidget->currentItem() < 0)
    return;
  unsigned long ip = contactList().getLastIPByUIN(listwidget->getCurrent()->getUIN());
  pingRequest(intIP2StringIP(ip));
  return;
}

void MainWindow::tracerouteRequest(QString ip)
{
 // system(QString("xterm -e bash -c \"traceroute ") + ip + " ; read\" &");
  return;
}

void MainWindow::tracerouteRequest(int userNumber)
{
  if(listwidget->currentItem() < 0)
    return;
  unsigned long ip = contactList().getLastIPByUIN(listwidget->getCurrent()->getUIN());
  tracerouteRequest(intIP2StringIP(ip));
  return;
}
