/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _MSGWINDOW_
#define _MSGWINDOW_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpushbt.h>
#include <qgrpbox.h>
#include <qlined.h>
#include <qlabel.h>
#include <qmlined.h>
#include <qcheckbox.h>

#include "icqwindow.h"

class WrapEdit;
class FwdList;
class FailDialog;
class ITButton;

class MsgWindow : public IcqWindow {
  Q_OBJECT
public:
  MsgWindow(const QString &, unsigned long, const QString &, const QString &);
  ~MsgWindow();
  void setUIN(unsigned long);
  void setName(const QString &);
  void setEMail(const QString &);
  void setMessage(const QString &);
  void stopCommand();
  void saveHistory();
  void requestNotify(int type, int length, void *data);
public slots:
signals:
protected:
  unsigned long uin;
  QString message;
  ITButton *morebutton;
  QPushButton *sendbutton, *cancelbutton,  *multibutton;
  QCheckBox *thrubtn;
  QGroupBox *tobox, *multibox;
  QLabel *uinlabel, *handlelabel, *emaillabel;
  QLineEdit *uinline, *handleline, *emailline;
  QPushButton *infobutton;
  QLabel *editlabel;
  WrapEdit *editbox;
  FwdList *multilist ;
  QLabel *updateanim;
  FailDialog *faildialog;
  void resizeEvent(QResizeEvent *);
  void closeEvent(QCloseEvent *);
  void sendMessage(int);
  void readsize();
protected slots:
  void savesize();
  void sendMessage();
  void cancelMessage();
  void infoRequest();
  void moreOptions() ;
  void multiRecpts() ;
  void failResult(int);
private:
private slots:
};
#endif /* _MSGWINDOW_ */
