/***************************************************************************
    description          : recvwindow.cpp
    begin                : Wed Apr 12 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <icq.h>
#include <qpalette.h>
#include <qobjectlist.h>
#include <qlayout.h>
#include <qhbuttongroup.h>
#include <qvbuttongroup.h>
#include <qframe.h>
#include <qdatetime.h>
#include <kglobal.h>
#include <klocale.h>
#include <kapp.h>
#include <kiconloader.h>
#include <kfiledialog.h>

#include "recvwindow.h"
#include "mainwindow.h"
#include "filewindow.h"
#include "userlist.h"
#include "useritem.h"
#include "kurllineedit.h"
#include "main.h"

#include "recvwindow.moc"


QPushButton *closebtn;

RecvDetail::RecvDetail(icqMessage *msg, QWidget *parent)
  : QWidget(parent)
{
  message = msg;
}

void RecvDetail::addRequest()
{
  MW->contactList().addNewToContactListByUIN(message->uin());
}

// Message event
//
// Handles MSG_RECV, MSG_SENT, MSG_PAGER_RECV, and MSG_EXPRESS_RECV

RecvMessage::RecvMessage(icqMessage *msg, QWidget *parent)
  : RecvDetail(msg, parent)
{


  QVBoxLayout *boxLayout = new QVBoxLayout(this, 2,2,"lay");

  QBoxLayout *labels = new QHBoxLayout( boxLayout);

  QLabel *ll = new QLabel(msg->typeString(),this);


  labels->addWidget(ll,10);

  msgedit = new QMultiLineEdit(this);
  msgedit->setText(message->body());
  msgedit->setWordWrap(QMultiLineEdit::WidgetWidth);
  msgedit->setWrapPolicy(QMultiLineEdit::AtWhiteSpace);
  msgedit->setMinimumHeight(msgedit->fontMetrics().height()*7);
  boxLayout->addWidget(msgedit);

  if(msg->type() != MSG_SENT) {

    QGroupBox *abox = new QGroupBox(  i18n( "Responce Action"  ), this );
    abox->setGeometry( QRect( 25, 40, 425, 58 ) );
    abox->setMaximumSize( QSize( 32767, 60 ) );
    abox->setColumnLayout(0, Qt::Vertical );
    abox->layout()->setSpacing( 0 );
    abox->layout()->setMargin( 0 );
    QHBoxLayout *hbox_abox = new QHBoxLayout( abox->layout() );
    hbox_abox->setAlignment( Qt::AlignTop );
    hbox_abox->setSpacing( 0 );
    hbox_abox->setMargin( 10 );

    QHBoxLayout* hbox_b = new QHBoxLayout;
    hbox_b->setSpacing( 0 );
    hbox_b->setMargin( 0 );

   if(MW->contactList().isUINInContactList(msg->uin())) {

    QPushButton *replybtnl = new QPushButton(i18n("&Reply"), abox);
    connect(replybtnl, SIGNAL(clicked()), SLOT(replyRequest()));

    hbox_b->addWidget( replybtnl );
    QSpacerItem* spacer_1 = new QSpacerItem( 216, 20, QSizePolicy::Expanding, QSizePolicy::Fixed );
    hbox_b->addItem( spacer_1 );

    QPushButton *chatbtn = new QPushButton(i18n("Re&quest Chat"), abox);
    connect(chatbtn, SIGNAL(clicked()), MW, SLOT(chatRequest()));

    hbox_b->addWidget( chatbtn );
    hbox_abox->addLayout( hbox_b );

    } else {

    QPushButton *replybtn = new QPushButton(i18n("&Reply"), abox);
    connect(replybtn, SIGNAL(clicked()), SLOT(replyRequest()));
    hbox_b->addWidget( replybtn );
    QSpacerItem* spacer_2 = new QSpacerItem( 216, 20, QSizePolicy::Expanding, QSizePolicy::Fixed );
    hbox_b->addItem( spacer_2 );

    QPushButton *addbtn = new QPushButton( i18n( "&Add To Contact List"), abox );
    connect(addbtn, SIGNAL(clicked()), SLOT(addRequest()));

    hbox_b->addWidget( addbtn );
    hbox_abox->addLayout( hbox_b );

     }

    boxLayout->addWidget(abox);


 }
}

void RecvMessage::replyRequest()
{
  MW->messageRequest(message->uin(), message->body());

  if(MW->isCloseRecv())
    topLevelWidget()->close();
}

// URL event

RecvURL::RecvURL(icqMessage *msg, QWidget *parent)
  : RecvDetail(msg, parent)
{


  QVBoxLayout *boxLayout = new QVBoxLayout(this, 2,2);

  QBoxLayout *labels = new QHBoxLayout( boxLayout);

  frame = new QLabel(msg->typeString(), this);

  labels->addWidget(frame,10);

  QVButtonGroup *urlbox = new QVButtonGroup(i18n("URL Description:"), this);
  urldesc = new QMultiLineEdit(urlbox);
  urldesc->setFocusPolicy(QWidget::NoFocus);
  urldesc->setText(message->body());
  urldesc->setMinimumHeight(urldesc->fontMetrics().height()*6);
  boxLayout->addWidget(urlbox);

  QHButtonGroup *url = new QHButtonGroup(this);

  QLabel *urllabel = new QLabel(i18n("URL:"), url);
  urledit = new KURLLineEdit(url);
  urledit->setText(message->url());
  urledit->setFocusPolicy(QWidget::NoFocus);
  urledit->setMaximumHeight(urledit->sizeHint().height());
  urllabel->setBuddy(urledit);
  urllabel->setMaximumHeight(urllabel->sizeHint().height());
  boxLayout->addWidget(url);

  if(msg->type() == MSG_URL_RECV) {

    QGroupBox *abox = new QGroupBox(  i18n( "Responce Action"  ), this );
    abox->setGeometry( QRect( 25, 40, 425, 58 ) );
    abox->setMaximumSize( QSize( 32767, 60 ) );
    abox->setColumnLayout(0, Qt::Vertical );
    abox->layout()->setSpacing( 0 );
    abox->layout()->setMargin( 0 );
    QHBoxLayout *hbox_abox = new QHBoxLayout( abox->layout() );
    hbox_abox->setAlignment( Qt::AlignTop );
    hbox_abox->setSpacing( 0 );
    hbox_abox->setMargin( 10 );

    QHBoxLayout* hbox_b = new QHBoxLayout;
    hbox_b->setSpacing( 0 );
    hbox_b->setMargin( 0 );

   if(MW->contactList().isUINInContactList(msg->uin())) {

    QPushButton *replybtnl = new QPushButton(i18n("&Reply"), abox);
    connect(replybtnl, SIGNAL(clicked()), SLOT(replyRequest()));

    hbox_b->addWidget( replybtnl );
    QSpacerItem* spacer_1 = new QSpacerItem( 216, 20, QSizePolicy::Expanding, QSizePolicy::Fixed );
    hbox_b->addItem( spacer_1 );

    QPushButton *chatbtn = new QPushButton(i18n("Re&quest Chat"), abox);
    connect(chatbtn, SIGNAL(clicked()), MW, SLOT(chatRequest()));
    hbox_b->addWidget( chatbtn );
    hbox_abox->addLayout( hbox_b );

    } else {

    QPushButton *replybtn = new QPushButton(i18n("&Reply"), abox);
    connect(replybtn, SIGNAL(clicked()), SLOT(replyRequest()));
    hbox_b->addWidget( replybtn );

    QSpacerItem* spacer_2 = new QSpacerItem( 216, 20, QSizePolicy::Expanding, QSizePolicy::Fixed );
    hbox_b->addItem( spacer_2 );

    QPushButton *addbtn = new QPushButton(i18n("&Add To Contact List"), abox);
    connect(addbtn, SIGNAL(clicked()), SLOT(addRequest()));

    hbox_b->addWidget( addbtn );
    hbox_abox->addLayout( hbox_b );

     }

    boxLayout->addWidget(abox);
  }
}

void RecvURL::replyRequest()
{
  MW->messageRequest(message->uin(), message->body());

  if(MW->isCloseRecv())
    topLevelWidget()->close();
}

// Authorize eventts

RecvAuth::RecvAuth(icqMessage *msg, QWidget *parent)
  : RecvDetail(msg, parent)
{
  QString title;

  switch(msg->type())
  {
    case MSG_AUTH_RECV:
      title = i18n("Authorization reason");
      break;
    case MSG_AUTH_GRANT:
      title = i18n("Authorization granted");
      break;
    case MSG_AUTH_REFUSE:
      title = i18n("Decline reason");
      break;
    default:
      title = "Unknown Authorization Event";
  }

  QBoxLayout *boxLayout = new QVBoxLayout( this, 2, 2);

  QBoxLayout *labels = new QHBoxLayout( boxLayout);

  frame = new QLabel(title, this);

  labels->addWidget(frame,10);

  msgedit = new QMultiLineEdit(this);
  msgedit->setText(message->body());
  msgedit->setMinimumHeight(msgedit->fontMetrics().height()*7);

    boxLayout->addWidget(msgedit);

    QGroupBox *abox = new QGroupBox( i18n( "Responce Action"  ), this );
    abox->setGeometry( QRect( 25, 40, 425, 58 ) );
    abox->setMaximumSize( QSize( 32767, 60 ) );
    abox->setColumnLayout(0, Qt::Vertical );
    abox->layout()->setSpacing( 0 );
    abox->layout()->setMargin( 0 );
    QHBoxLayout *hbox_abox = new QHBoxLayout( abox->layout() );
    hbox_abox->setAlignment( Qt::AlignTop );
    hbox_abox->setSpacing( 0 );
    hbox_abox->setMargin( 10 );

    QHBoxLayout* hbox_b = new QHBoxLayout;
    hbox_b->setSpacing( 0 );
    hbox_b->setMargin( 0 );

    QPushButton *declinebtn = new QPushButton(i18n("&Decline"), abox);
    connect(declinebtn, SIGNAL(clicked()), SLOT(declineRequest()));

    hbox_b->addWidget( declinebtn );
    QSpacerItem* spacer_d = new QSpacerItem( 216, 20, QSizePolicy::Expanding, QSizePolicy::Fixed );
    hbox_b->addItem( spacer_d );

    QPushButton *authbtn = new QPushButton(i18n("&Authorize"), abox);
    connect(authbtn, SIGNAL(clicked()), SLOT(authorizeRequest()));

    hbox_b->addWidget( authbtn );
    hbox_abox->addLayout( hbox_b );

    boxLayout->addWidget(abox);

  if(msg->type() != MSG_AUTH_RECV) {

    declinebtn->setEnabled(false);
    authbtn->setEnabled(false);
  }
}

void RecvAuth::authorizeRequest()
{

  if(MW->isLogged())
    icq_SendAuthMsg(MW->icqlink, message->uin());

  QMessageBox::information(topLevelWidget(),i18n("Authorization Granted"),
               i18n("User has been authorized to add to Contact List"),
               i18n("OK"), 0);
}

void RecvAuth::declineRequest()
{

  QMessageBox::information(topLevelWidget(),i18n("Auth declined"),
               i18n("User is not authorized to add to Contact List"),
               i18n("OK"), 0);

}

// Chat Request Event

RecvChatReq::RecvChatReq(icqMessage *msg, QWidget *parent)
  : RecvDetail(msg, parent)
{

  QBoxLayout *hl = new QVBoxLayout( this,2,2 );
  QBoxLayout *labels = new QHBoxLayout(hl);

  frame = new QLabel("Chat Request Received", this);
  labels->addWidget(frame,10);

  msgedit = new QMultiLineEdit(this);
  msgedit->setText(message->body());
  msgedit->setMinimumHeight(msgedit->fontMetrics().height()*7);
  hl->addWidget(msgedit);

  QGroupBox *abox = new QGroupBox( i18n( "Responce Action"  ), this );
  abox->setGeometry( QRect( 25, 40, 425, 58 ) );
  abox->setMaximumSize( QSize( 32767, 60 ) );
  abox->setColumnLayout(0, Qt::Vertical );
  abox->layout()->setSpacing( 0 );
  abox->layout()->setMargin( 0 );
  QHBoxLayout *hbox_abox = new QHBoxLayout( abox->layout() );
  hbox_abox->setAlignment( Qt::AlignTop );
  hbox_abox->setSpacing( 0 );
  hbox_abox->setMargin( 10 );

  QHBoxLayout* hbox_b = new QHBoxLayout;
  hbox_b->setSpacing( 0 );
  hbox_b->setMargin( 0 );

  QPushButton *declinebtn = new QPushButton(i18n("&Decline"), abox);
  connect(declinebtn, SIGNAL(clicked()), SLOT(declineRequest()));

  hbox_b->addWidget( declinebtn );
  QSpacerItem* spacer_d = new QSpacerItem( 216, 20, QSizePolicy::Expanding, QSizePolicy::Fixed );
  hbox_b->addItem( spacer_d );

  QPushButton *acceptbtn = new QPushButton(i18n("&Accept"), abox);
  connect(acceptbtn, SIGNAL(clicked()), SLOT(acceptRequest()));

  hbox_b->addWidget( acceptbtn );
  hbox_abox->addLayout( hbox_b );

  hl->addWidget(abox);

}

void RecvChatReq::acceptRequest()
{
  icq_AcceptChatRequest(MW->icqlink, message->uin(), message->seq());
  topLevelWidget()->close();
}

void RecvChatReq::declineRequest()
{
  // TODO: add chat req decline code, needs icqlib support 1st
  topLevelWidget()->close();
}

// File Request

RecvFileReq::RecvFileReq(icqMessage *msg, QWidget *parent)
  : RecvDetail(msg, parent)
{
  QBoxLayout *hl = new QVBoxLayout( this,2,2 );
  QBoxLayout *labels = new QHBoxLayout(hl);

  frame = new QLabel("File Request Received", this);
  labels->addWidget(frame,10);

  msgedit = new QMultiLineEdit(this);
  msgedit->setText(message->body());
  msgedit->setMinimumHeight(msgedit->fontMetrics().height()*7);
  hl->addWidget(msgedit);

  QHButtonGroup *aBox = new QHButtonGroup(i18n("Response Action"), this);

  QPushButton *declinebtn =new QPushButton(i18n("&Decline"), aBox);
//  connect(declinebtn, SIGNAL(clicked()), SLOT(declineRequest()));
  declinebtn->setEnabled(false);

  QPushButton *savebtn = new QPushButton(i18n("&Save"), aBox);
  connect(savebtn, SIGNAL(clicked()), SLOT(saveRequest()));
  QPushButton *saveasbtn = new QPushButton(i18n("Save &As..."), aBox);
  connect(saveasbtn, SIGNAL(clicked()), SLOT(saveAsRequest()));

   if (!message->isNew()) {
    savebtn->setEnabled(false);
    saveasbtn->setEnabled(false);
  }

  hl->addWidget(aBox);

}

void RecvFileReq::saveRequest()
{
  icq_FileSession *pfile = icq_AcceptFileRequest(MW->icqlink, message->uin(), message->seq() );
  QString drnick = MW->contactList().getNickByUIN(message->uin());
  QString recvdir = QString("ReceivedFiles/%1/").arg(drnick);
  QString directory = locateLocal("appdata", recvdir);
  icq_FileSessionSetWorkingDir(pfile, directory.latin1());
  topLevelWidget()->close();
}

void RecvFileReq::saveAsRequest()
{
  QString directory;
  char working_dir[1024];

  getcwd(working_dir, 1024);

  directory=KFileDialog::getExistingDirectory(working_dir);

  if(!directory.isEmpty())
  {
    icq_FileSession *pfile = icq_AcceptFileRequest(MW->icqlink, message->uin(), message->seq() );
    icq_FileSessionSetWorkingDir(pfile, directory.latin1());
    topLevelWidget()->close();
  }

}
void RecvFileReq::declineRequest()
{
  // TODO: add file req decline code, needs icqlib support 1st
}

// Message event

RecvAdded::RecvAdded(icqMessage *msg, QWidget *parent)
  : RecvDetail(msg, parent)
{

    QBoxLayout *hl = new QVBoxLayout( this,2,2 );
    QBoxLayout *labels = new QHBoxLayout(hl);

    frame = new QLabel(msg->typeString(),this);
    labels->addWidget(frame);

    QLabel *addedlabel = new QLabel(i18n("You were added to the user's contact list"),this);
    addedlabel->setAlignment(AlignCenter);
    hl->addWidget(addedlabel);

    QGroupBox *abox = new QGroupBox(  i18n( "Responce Action"  ), this );
    abox->setGeometry( QRect( 25, 40, 425, 58 ) );
    abox->setMaximumSize( QSize( 32767, 60 ) );
    abox->setColumnLayout(0, Qt::Vertical );
    abox->layout()->setSpacing( 0 );
    abox->layout()->setMargin( 0 );
    QHBoxLayout *hbox_abox = new QHBoxLayout( abox->layout() );
    hbox_abox->setAlignment( Qt::AlignTop );
    hbox_abox->setSpacing( 0 );
    hbox_abox->setMargin( 10 );

    QHBoxLayout* hbox_b = new QHBoxLayout;
    hbox_b->setSpacing( 0 );
    hbox_b->setMargin( 0 );

   if(MW->contactList().isUINInContactList(msg->uin())) {

    QPushButton *replybtnl = new QPushButton(i18n("&Reply"), abox);
    connect(replybtnl, SIGNAL(clicked()), SLOT(replyRequest()));

    hbox_b->addWidget( replybtnl );
    QSpacerItem* spacer_1 = new QSpacerItem( 216, 20, QSizePolicy::Expanding, QSizePolicy::Fixed );
    hbox_b->addItem( spacer_1 );

    QPushButton *chatbtn = new QPushButton(i18n("Re&quest Chat"), abox);
    connect(chatbtn, SIGNAL(clicked()), MW, SLOT(chatRequest()));
    hbox_b->addWidget( chatbtn );
    hbox_abox->addLayout( hbox_b );

    } else {

    QPushButton *replybtn = new QPushButton(i18n("&Reply"), abox);
    connect(replybtn, SIGNAL(clicked()), SLOT(replyRequest()));
    hbox_b->addWidget( replybtn );
    QSpacerItem* spacer_2 = new QSpacerItem( 216, 20, QSizePolicy::Expanding, QSizePolicy::Fixed );
    hbox_b->addItem( spacer_2 );

    QPushButton *addbtn = new QPushButton(i18n("&Add To Contact List"), abox);
    connect(addbtn, SIGNAL(clicked()), SLOT(addRequest()));

    hbox_b->addWidget( addbtn );
    hbox_abox->addLayout( hbox_b );

     }
  hl->addWidget(abox);
}

void RecvAdded::replyRequest()
{
  MW->messageRequest(message->uin(), message->body());

  if(MW->isCloseRecv())
    topLevelWidget()->close();
}

RecvWindow::RecvWindow(QList<icqMessage> *l, int i, unsigned long u, bool d)
  : IcqWindow(d)
{
    setIcon(UserIcon("message"));

    list = l;
    start = idx = i;
    msgUin = u;
    delflag = d;

    vbox = new QVBoxLayout( this );
    vbox->setSpacing( 4 );
    vbox->setMargin( 2 );

    frombox = new QGroupBox( this, "frombox" );
    frombox->setTitle( i18n( "From"  ) );
    frombox->setLineWidth( 1 );
    frombox->setMaximumSize( QSize( 32767, 80 ) );
    frombox->setColumnLayout(0, Qt::Vertical );
    frombox->layout()->setSpacing( 0 );
    frombox->layout()->setMargin( 0 );
    grid = new QGridLayout( frombox->layout() );
    grid->setAlignment( Qt::AlignTop );
    grid->setSpacing( 5 );
    grid->setMargin( 8 );

///////////////////////////////////////////////////////////////////////////
 //  icqMessage *m;
  // QPixmap statpix;
  statuslabel = new QLabel( frombox, "statuslabel" );
/*
  if(MW->contactList().getStatusByUIN(m->uin()) & STATUS_OFFLINE == STATUS_OFFLINE)
     {
    statpix= UserIcon("coffline");
     }
   if((MW->contactList().getStatusByUIN(m->uin()) & STATUS_INVISIBLE) == STATUS_INVISIBLE)
     {
    statpix= UserIcon("cprivacy");
     }
   if((MW->contactList().getStatusByUIN(m->uin()) & STATUS_FREE_CHAT) == STATUS_FREE_CHAT)
    {
    statpix=UserIcon("cfreechat");
    }
   if((MW->contactList().getStatusByUIN(m->uin()) & STATUS_DND) == STATUS_DND)
    {
    statpix = UserIcon("cdnd");
    }
   if((MW->contactList().getStatusByUIN(m->uin()) & STATUS_OCCUPIED) == STATUS_OCCUPIED)
    {
    statpix= UserIcon("coccupied");
    }
   if((MW->contactList().getStatusByUIN(m->uin()) & STATUS_NA) == STATUS_NA)
    {
    statpix= UserIcon("cna");
     }
   if((MW->contactList().getStatusByUIN(m->uin()) & STATUS_AWAY) == STATUS_AWAY)
    {
    statpix=UserIcon("caway");
    }

    statuslabel->setPixmap( statpix );
*/
////////////////////////////////////////////////////////////////////////////
  //  statuslabel->setScaledContents( FALSE );
  //  statuslabel->setAlignment( int( QLabel::AlignCenter ) );
    statuslabel->setMaximumSize( QSize( 22, 22 ) );
    statuslabel->setMinimumSize( QSize( 22, 22 ) );

    grid->addWidget( statuslabel, 1, 1 );

    dateline = new QLineEdit( frombox, "dateline" );
    dateline->setAlignment( int( QLineEdit::AlignCenter ) );
    dateline->setFocusPolicy( QLineEdit::NoFocus );

    grid->addWidget( dateline, 1, 4 );

    timelabel = new QLabel( frombox, "timelabel" );
    timelabel->setText( i18n( "Time:"  ) );
    QFont timelabel_font(  timelabel->font() );
    timelabel_font.setBold( TRUE );
    timelabel->setFont( timelabel_font );

    grid->addWidget( timelabel, 1, 5 );

    timeline = new QLineEdit( frombox, "timeline" );
    timeline->setAlignment( int( QLineEdit::AlignCenter ) );
    timeline->setEdited( FALSE );
    timeline->setFrame( TRUE );
    timeline->setBackgroundOrigin( QLineEdit::WidgetOrigin );
    timeline->setFocusPolicy( QLineEdit::NoFocus );

    grid->addMultiCellWidget( timeline, 1, 1, 6, 7 );

    handlelabel = new QLabel( frombox, "handlelabel" );
    handlelabel->setText( i18n( "Nick Name:"  ) );
    QFont handlelabel_font(  handlelabel->font() );
    handlelabel_font.setBold( TRUE );
    handlelabel->setFont( handlelabel_font );

    grid->addMultiCellWidget( handlelabel, 0, 0, 0, 1 );

    handleline = new QLineEdit( frombox, "handleline" );
    handleline->setAlignment( int( QLineEdit::AlignCenter ) );
    handleline->setFocusPolicy( QLineEdit::NoFocus );

    grid->addWidget( handleline, 0, 2 );

    emaillabel = new QLabel( frombox, "emaillabel" );
    emaillabel->setText( i18n( "EMail:"  ) );
    QFont emaillabel_font(  emaillabel->font() );
    emaillabel_font.setBold( TRUE );
    emaillabel->setFont( emaillabel_font );

    grid->addWidget( emaillabel, 0, 3 );

    emailline = new QLineEdit( frombox, "emailline" );
    emailline->setAlignment( int( QLineEdit::AlignCenter ) );
    emailline->setFocusPolicy( QLineEdit::NoFocus );

    grid->addMultiCellWidget( emailline, 0, 0, 4, 6 );

    infobutton = new QPushButton( frombox, "infobutton" );
    infobutton->setFlat( TRUE );
    infobutton->setPixmap( UserIcon("info2") );
    infobutton->setMinimumSize( QSize( 22, 22 ) );
    infobutton->setMaximumSize( QSize( 22, 22 ) );
    connect(infobutton, SIGNAL(clicked()), this, SLOT(infoRequest()));
    grid->addWidget( infobutton, 0, 7 );

    uinline = new QLineEdit( frombox, "uinline" );
    uinline->setAlignment( int( QLineEdit::AlignCenter ) );
    uinline->setFocusPolicy( QLineEdit::NoFocus );

    grid->addWidget( uinline, 1, 2 );

    datelabel = new QLabel( frombox, "datelabel" );
    datelabel->setText( i18n( "Date:"  ) );
    QFont datelabel_font(  datelabel->font() );
    datelabel_font.setBold( TRUE );
    datelabel->setFont( datelabel_font );

    grid->addWidget( datelabel, 1, 3 );

    uinlabel = new QLabel( frombox, "uinlabel" );
    uinlabel->setText( i18n( "ICQ#:"  ) );
    QFont uinlabel_font(  uinlabel->font() );
    uinlabel_font.setBold( TRUE );
    uinlabel->setFont( uinlabel_font );

    grid->addWidget( uinlabel, 1, 0 );
    vbox->addWidget( frombox );

    detail = new QWidgetStack( this, "detail" );
    detail->setMinimumSize( QSize( 0, 150 ) );
    vbox->addWidget( detail );

    hbox = new QHBoxLayout;
    hbox->setSpacing( 4 );
    hbox->setMargin( 0 );
    QSpacerItem* spacer = new QSpacerItem( 360, 20, QSizePolicy::Expanding, QSizePolicy::Fixed );
    hbox->addItem( spacer );

    closebtn = new QPushButton(this, "closebtn");
    closebtn->setText(i18n("&Close"));
    hbox->addWidget( closebtn );

    nextbtn = new QPushButton(this, "nextbtn");
    nextbtn->setText(i18n("Read &Next"));
    hbox->addWidget( nextbtn );
    vbox->addLayout( hbox );

    connect(closebtn, SIGNAL(clicked()), SLOT(closeBtn()));
    connect(nextbtn, SIGNAL(clicked()), SLOT(readNext()));

    readsize();
    readNext();

}
RecvWindow::~RecvWindow()
{

  delete statuslabel;

}

void RecvWindow::closeEvent(QCloseEvent *ce) {
  savesize();
  IcqWindow::closeEvent(ce);
}

void RecvWindow::setUIN(unsigned long u)
{
  QString text;
  text.setNum(u);
  uinline->setText(text);
}

void RecvWindow::setName(const QString &name)
{
  nick = name;
  handleline->setText(name);
}

void RecvWindow::setEMail(const QString &pemail)
{
  email = pemail;
  emailline->setText(email);
}

void RecvWindow::setTime(TimeStr msgtime)
{
  QString date;
  QString time;
  date = KGlobal::locale()->formatDate(QDate(msgtime.year,msgtime.month,msgtime.day),true);
  dateline->setText(date);
  time = KGlobal::locale()->formatTime(QTime(msgtime.hour,msgtime.minute));
  timeline->setText(time);
}

void RecvWindow::closeBtn()
{
  close();
}

void RecvWindow::infoRequest()
{
   MW->infoWindow(msgUin);
}

void RecvWindow::readNext()
{
  if(start != idx && list->count() - 1 > (unsigned int)idx)
    idx++;
  if(start == idx)
    start = -1;

  icqMessage *msg = list->at(idx);

  makeWindow(msg);

  if(msg->type() != MSG_AUTH_RECV && msg->type() != MSG_PAGER_RECV &&
     msg->type() != MSG_EXPRESS_RECV)
  {
    setName(MW->contactList().getNickByUIN(msg->uin()));
    setEMail(MW->contactList().getEMailByUIN(msg->uin()));
  }
  else
  {
    if(msg->nick().latin1())
      setName(msg->nick());
    else
      setName(MW->contactList().getNickByUIN(msg->uin()));
    if(msg->email().latin1())
      setEMail(msg->email());
    else
      setEMail(MW->contactList().getEMailByUIN(msg->uin()));
  }
  setUIN(msg->uin());
  setTime(msg->time());

  msg->expire();

  QString eventInfo;

  if(list->count() - 1 > (unsigned int)idx)
  {
    nextbtn->setEnabled(TRUE);
    eventInfo = "";
  }
  else
  {
    nextbtn->setEnabled(FALSE);
    if(delflag)
      MW->listWidget()->setBlinkingByUIN(msg->uin(),FALSE);
    eventInfo = i18n(" (No More Events)");
  }
  if(delflag)
    MW->updateBlinking();

  QString recvCaption = msg->typeTitleString();

  setCaption((const QString &)(recvCaption + eventInfo));
}

void RecvWindow::updateNextAvailability()
{
  if(list->count() - 1 > (unsigned int)idx)
  {
    nextbtn->setEnabled(TRUE);
    setCaption(recvCaption);
  }
  else
    nextbtn->setEnabled(FALSE);
}

void RecvWindow::makeWindow(icqMessage *msg)
{
  static int x=1;
  RecvDetail *oldWidget = NULL;

  QObjectList *list = detail->queryList(0, 0, true, false);
  QObjectListIt it(*list); 
  QObject *obj;
  while((obj=it.current()) != 0) // for each found object...
  {
    if(obj->inherits("RecvDetail"))
       oldWidget = (RecvDetail *)obj;
    ++it;
  }

  delete list;

  RecvDetail *p = NULL;

  switch(msg->type())
  {
    case MSG_SENT:
    case MSG_RECV:
    case MSG_PAGER_RECV:
    case MSG_EXPRESS_RECV:
      p = new RecvMessage(msg, detail);
      break;
    case MSG_URL_SENT:
    case MSG_URL_RECV:
      p = new RecvURL(msg, detail);
      break;
    case MSG_CHAT_REQ_RECV:
      p = new RecvChatReq(msg, detail);
      break;
    case MSG_FILE_REQ_RECV:
      p = new RecvFileReq(msg, detail);
      break;
    case MSG_AUTH_RECV:
    case MSG_AUTH_GRANT:
    case MSG_AUTH_REFUSE:
      p = new RecvAuth(msg, detail);
      break;
    case MSG_ADDED:
      p = new RecvAdded(msg, detail);
      break;
    default:
      break;
  }

  if(p) {
  	detail->addWidget(p, x++);
  	detail->raiseWidget(p);
  }

  if(oldWidget) {
     detail->removeWidget(oldWidget);
     delete oldWidget;
  }

  return;
}

void RecvWindow::readsize()
{
  db->setPath( MW->getOwnerPath() + "/Geometry/RecvWindow" );

  int w = db->readEntry("width").toInt();
  int h = db->readEntry("height").toInt();
  int x = db->readEntry("x").toInt();
  int y = db->readEntry("y").toInt();
  setMinimumSize( QSize( 465,310 ) );
  resize(QSize(w, h));
  move(QPoint(x, y));
}

void RecvWindow::savesize()
{
  db->setPath( MW->getOwnerPath() + "/Geometry/RecvWindow" );

  db->writeEntry("width", this->width());
  db->writeEntry("height", this->height());
  db->writeEntry("x", this->x());
  db->writeEntry("y", this->y());

  db->flush( true );
}


