/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _URLSNDWIN_
#define _URLSNDWIN_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qpushbt.h>
#include <qgrpbox.h>
#include <qlined.h>
#include <qlabel.h>
#include <qmlined.h>

#include "icqwindow.h"

class FailDialog;
class KURLLineEdit;

class URLSndWindow : public IcqWindow {
  Q_OBJECT
public:
  URLSndWindow(const QString &, unsigned long, const QString &);
  ~URLSndWindow();
  void setUIN(unsigned long);
  void setName(const QString &);
  void setEMail(const QString &);
  void stopCommand();
  void saveHistory();
  void requestNotify(int type, int length, void *data);
public slots:
signals:
protected:
  unsigned long uin;
  QString message;
  QPushButton *sendbutton, *cancelbutton;
  QGroupBox *tobox;
  QLabel *uinlabel, *handlelabel, *emaillabel;
  QLineEdit *uinline, *handleline, *emailline;
  QPushButton *infobutton;
  QLabel *editlabel, *urllabel;
  QMultiLineEdit *editbox;
  KURLLineEdit *urlbox;
  QLabel *updateanim;
  long sendSeq;
  FailDialog *faildialog;
  void resizeEvent(QResizeEvent *);
  void sendURL(int);
protected slots:
  void sendURL();
  void cancelURL();
  void infoRequest();
  void failResult(int);
private:
private slots:
};
#endif /* _URLSNDWIN_ */
