/***************************************************************************
    description          : mydetails.cpp
    begin                : Thu Sep 14 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qpixmap.h>
#include <qmsgbox.h>
#include <qmovie.h>

#include "mainwindow.h"
#include "mydetails.h"
#include "mydetailsmain.h"
#include "mydetailshome.h"
#include "mydetailsmore.h"
#include "mydetailswork.h"
#include "mydetailsabout.h"
#include "mydetailspics.h"

#include "mydetails.moc"

MyInfoWin::MyInfoWin() : IcqWindow()
{

  setIcon(UserIcon("info2"));

  setFixedSize(422, 330);

  myinfotab = new QTabWidget(this);
  myinfotab->setGeometry(4, 4, 414, 282);
  mainwidget = new MyMainWidget(myinfotab);
  homewidget = new MyHomeWidget(myinfotab);
  morewidget = new MyMoreWidget(myinfotab);
  workwidget = new MyWorkWidget(myinfotab);
  infowidget = new MyAboutWidget(myinfotab);

  myinfotab->addTab(mainwidget,QPixmap(main_xpm),i18n("Main"));
  myinfotab->addTab(homewidget,QPixmap(home_xpm),i18n("Home"));
  myinfotab->addTab(workwidget,QPixmap(work_xpm),i18n("Work"));
  myinfotab->addTab(morewidget,QPixmap(more_xpm),i18n("More"));
  myinfotab->addTab(infowidget,QPixmap(info_xpm),i18n("Info/About"));

  cancelbtn = new QPushButton(i18n("&Cancel"),this);
  cancelbtn->setGeometry(6, 300, 80, 25);
  connect(cancelbtn, SIGNAL(clicked()), SLOT(cancelCommand()));

  updatebtn = new QPushButton(i18n("Update From Database"),this);
  updatebtn->setGeometry(140, 300, 150, 25);
  connect(updatebtn, SIGNAL(clicked()), SLOT(updateFromServer()));

  savebtn = new QPushButton(i18n("Save"),this);
  savebtn->setGeometry(295, 300, 80, 25);
  connect(savebtn, SIGNAL(clicked()), SLOT(saveCommand()));
  savebtn->setDefault(true);

  saveanim = new QLabel(this);
  saveanim->setGeometry(380, 289, 32, 32);
  saveanim->setFixedSize(QSize(32, 32)+QSize(4, 4));
  saveanim->setFrameStyle(QFrame::WinPanel | QFrame::Sunken);
  saveanim->setAlignment(AlignCenter);

  QString filename = locate("kicq_pics","search.gif");
  QFile testfile(filename);
  if(!testfile.exists())
  filename = locate("kicq_pics","search.gif");
  saveanim->setMovie(QMovie((const QString &)filename));
  saveanim->movie()->pause();
  saveanim->movie()->restart();


}

void MyInfoWin::closeEvent(QCloseEvent *ce)
{
  IcqWindow::closeEvent(ce);
}

void MyInfoWin::cancelCommand()
{
  close();
}

void MyInfoWin::saveCommand()
{
 // MW->saveConfigUser
}
void MyInfoWin::setMainWidgetUIN(const QString &text, const QString &nick)
{
 mainwidget->setMyUIN(text, nick);
}

void MyInfoWin::setMainWidgetNames(const QString &first, const QString &last)
{
 mainwidget->setMyNames(first,last);
}
void MyInfoWin::updateFromServer()
{

}
