/***************************************************************************
    description          : mydetailshome.cpp
    begin                : Thu Sep 14 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <icq.h>
#include <time.h>
#include <qdatetime.h>
#include <qtimer.h>
#include <qbuttongroup.h>
#include "mydetails.h"
#include "mydetailshome.h"
#include "mainwindow.h"
#include "mydetailspics.h"
#include "corewidget.h"

#include "mydetailshome.moc"


MyHomeWidget::MyHomeWidget(QWidget *parent) : QWidget(parent)
{

  QButtonGroup *homebox = new QButtonGroup(this);
  homebox->setGeometry(2, 6, 404, 121);
  homebox->setFrameStyle(QFrame::Box | QFrame::Sunken);
  homebox->setTitle(i18n("Home Address"));

  QLabel *stlabel = new QLabel(i18n("Street"),homebox);
  stlabel->setGeometry(10, 18, 45, 16);
  stlabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  stlabel->setFrameStyle(QFrame::NoFrame);
  stlabel->setAlignment(AlignLeft | AlignVCenter);

  QLabel *adrlabel = new QLabel(i18n("Address:"),homebox);
  adrlabel->setGeometry(10, 33, 54, 19);
  adrlabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  adrlabel->setFrameStyle(QFrame::NoFrame);
  adrlabel->setAlignment(AlignLeft | AlignVCenter);

  addressline = new QMultiLineEdit(homebox);
  addressline->setGeometry(66, 18, 140, 62);
  addressline->setFrameStyle(QFrame::Panel | QFrame::Sunken);

  mapbut = new QPushButton(homebox);
  mapbut->setGeometry(66, 92, 140, 20);
  mapbut->setText(i18n("Display Map"));

  QLabel *citylabel = new QLabel(i18n("City:"),homebox);
  citylabel->setGeometry(220, 18, 32, 20);
  citylabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  citylabel->setFrameStyle(QFrame::NoFrame);
  citylabel->setAlignment(AlignLeft | AlignVCenter);

  cityline = new QLineEdit(homebox);
  cityline->setGeometry(285, 18, 110, 20);

  QLabel *statelabel = new QLabel(i18n("State:"),homebox);
  statelabel->setGeometry(220, 43, 48, 20);
  statelabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  statelabel->setFrameStyle(QFrame::NoFrame);
  statelabel->setAlignment(AlignLeft | AlignVCenter);

  stateline = new QLineEdit(homebox);
  stateline->setGeometry(285, 43, 110, 20);

  QLabel *ziplabel = new QLabel(i18n("Zip Code:"),homebox);
  ziplabel->setGeometry(220, 67, 61, 20);
  ziplabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  ziplabel->setFrameStyle(QFrame::NoFrame);
  ziplabel->setAlignment(AlignLeft | AlignVCenter);

  zipline = new QLineEdit(homebox);
  zipline->setGeometry(285, 67, 110, 20);

  QLabel *countrylabel = new QLabel(i18n("Country:"),homebox);
  countrylabel->setGeometry(220, 92, 56, 18);
  countrylabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  countrylabel->setFrameStyle(QFrame::NoFrame);
  countrylabel->setAlignment(AlignLeft | AlignTop);

  countryline = new QComboBox(FALSE,homebox);
  countryline->setGeometry(285, 92, 110, 20);
  QStrList ctrList;
  ctrList.inSort("");
  for(int i=0; icq_Countries[i].code!=0xffff; i++)
    ctrList.inSort(icq_Countries[i].name);
  countryline->insertStrList(&ctrList);
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  QButtonGroup *phbox = new QButtonGroup(this);
  phbox->setGeometry(2, 131, 404, 119);
  phbox->setFrameStyle(QFrame::Box | QFrame::Sunken);

  QLabel *timelabel = new QLabel(i18n("Your Time:"),phbox);
  timelabel->setGeometry(239, 54, 63, 20);
  timelabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  timelabel->setFrameStyle(QFrame::NoFrame);
  timelabel->setAlignment(AlignLeft | AlignVCenter);

  timeline = new ULine(phbox,true);
  timeline->setGeometry(308, 54, 85, 20);
  timeline->setAlignment(Qt::AlignHCenter);
  timeline->setFocusPolicy(QWidget::NoFocus);
   setMyTime();

  QLabel *gmtlabel = new QLabel(i18n("Offset:"),phbox);
  gmtlabel->setGeometry(239, 10, 42, 20);
  gmtlabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  gmtlabel->setFrameStyle(QFrame::NoFrame);
  gmtlabel->setAlignment(AlignLeft | AlignVCenter);

  gmtcombo = new QComboBox((bool)0,phbox);
  gmtcombo->setGeometry(285, 10, 110, 20);
  gmtcombo->insertItem(i18n("(GMT +02:00)"));

///////////////////////////////////////////////////////////////////////////////////////
  QLabel *phlabel = new QLabel(i18n("Phone:"),phbox);
  phlabel->setGeometry(10, 20, 44, 20);
  phlabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  phlabel->setFrameStyle(QFrame::NoFrame);
  phlabel->setAlignment(AlignLeft | AlignVCenter);

  phline = new QLineEdit(phbox);
  phline->setGeometry(66, 20, 140, 20);

  QLabel *phico = new QLabel(phbox);
  phico->setGeometry(210, 22, 18, 17);
  phico->setFrameStyle(QFrame::NoFrame);
  phico->setAlignment(AlignHCenter | AlignVCenter);
  phico->setPixmap(QPixmap(ph_xpm));

///////////////////////////////////////////////////////////
  QLabel *faxlabel = new QLabel(i18n("Fax:"),phbox);
  faxlabel->setGeometry(10, 54, 34, 20);
  faxlabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  faxlabel->setFrameStyle(QFrame::NoFrame);
  faxlabel->setAlignment(AlignLeft | AlignVCenter);

  faxline = new QLineEdit(phbox);
  faxline->setGeometry(66, 54, 140, 21);

  QLabel *faxico = new QLabel(phbox);
  faxico->setGeometry(210, 57, 18, 17);
  faxico->setFrameStyle(QFrame::NoFrame);
  faxico->setAlignment(AlignHCenter | AlignVCenter);
  faxico->setPixmap(QPixmap(fax_xpm));
/////////////////////////////////////////////////////////////
  QLabel *celllabel = new QLabel(i18n("Cellular:"),phbox);
  celllabel->setGeometry(10, 90, 49, 20);
  celllabel->setFont(QFont("Helvetica", 12, QFont::Bold, (int)0));
  celllabel->setFrameStyle(QFrame::NoFrame);
  celllabel->setAlignment(AlignLeft | AlignVCenter);

  cellline = new QLineEdit(phbox);
  cellline->setGeometry(66, 90, 140, 20);

  QLabel *cellico = new QLabel(phbox);
  cellico->setGeometry(210, 92, 18, 17);
  cellico->setFrameStyle(QFrame::NoFrame);
  cellico->setAlignment(AlignHCenter | AlignVCenter);
  cellico->setPixmap(QPixmap(cell_xpm));
}

MyHomeWidget::~MyHomeWidget()
{
}

void MyHomeWidget::setMyTime()
{
   time_t te = time(NULL);
   QDateTime t;
   t.setTime_t(te);
   timeline->setText(t.time().toString());

   QTimer *updatetime = new QTimer(this);
   connect(updatetime, SIGNAL(timeout()), this, SLOT(slotUpdateTime()));
   updatetime->start(1000);
}

void MyHomeWidget::slotUpdateTime()
{
  QDateTime t;
  t.setTime_t(time(NULL));
  timeline->setText(timeline->text().replace(0, t.time().toString().length(), t.time().toString()));
}
