/***************************************************************************
    description          : pref_misc.cpp
    begin                : Wed Apr 12 2000
    copyright            : (C) 2000 by Florian Veskov
    email                : napalmbox@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qlayout.h>
#include "main.h"

#include "pref_misc.h"

#include "pref_misc.moc"

OtherWidget::OtherWidget(QWidget *parent) : QWidget(parent)
{
  QBoxLayout *topLayout = new QVBoxLayout(this);
  topLayout->addSpacing(7);
  QGroupBox *otherbox = new QGroupBox(i18n("Other"), this);

  QBoxLayout *boxLayout = new QVBoxLayout(otherbox, 10, 7);

  boxLayout->addSpacing(7);

  recodebox = new QCheckBox(i18n("Cyrillic koi8-r - cp1251 recoding"), otherbox);
  recodebox->setMinimumSize(recodebox->sizeHint());
  boxLayout->addWidget(recodebox);

  closebox = new QCheckBox(i18n("Close Receive window when replying"), otherbox);
  closebox->setMinimumSize(closebox->sizeHint());
  boxLayout->addWidget(closebox);

  crlfbox = new QCheckBox(i18n("Convert <LF> to <CR><LF>"), otherbox);
  crlfbox->setMinimumSize(crlfbox->sizeHint());
  boxLayout->addWidget(crlfbox);

  quotebox = new QCheckBox(i18n("Quote original message when replying"), otherbox);
  quotebox->setMinimumSize(quotebox->sizeHint());
  boxLayout->addWidget(quotebox);

  reconbox = new QCheckBox(i18n("Reconnect on disconnect"), otherbox);
  reconbox->setMinimumSize(reconbox->sizeHint());
  boxLayout->addWidget(reconbox);

  topLayout->addWidget(otherbox);
  topLayout->addStretch(1);

}

void OtherWidget::setInfo(int rus, int closereply, int crlf, int quote, int recon)
{
  recodebox->setChecked(rus);
  closebox->setChecked(closereply);
  crlfbox->setChecked(crlf);
  quotebox->setChecked(quote);
  reconbox->setChecked(recon);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
MiscTab::MiscTab(QWidget *parent, const char *name)
: QTabWidget(parent, name)
{

}

MiscWidget::MiscWidget(QWidget *parent, const char *name)
: QWidget(parent, name)
{
  QBoxLayout *topLayout = new QVBoxLayout(this);
  QLabel *mainlabel = new QLabel(i18n(" Miscellaneous"),this);
  mainlabel->setFont(QFont("Helvetica", 12, QFont::Bold, FALSE));
 QPalette pal;
    QColorGroup cg;
    cg.setColor( QColorGroup::Foreground, QColor( 0, 37, 172) );
    cg.setColor( QColorGroup::Button, QColor( 220, 220, 220) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 237, 237, 237) );
    cg.setColor( QColorGroup::Dark, QColor( 110, 110, 110) );
    cg.setColor( QColorGroup::Mid, QColor( 146, 146, 146) );
    cg.setColor( QColorGroup::Text, QColor( 0, 0, 255) );
    cg.setColor( QColorGroup::BrightText, white );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 255, 255, 169) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setActive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 0, 37, 172) );
    cg.setColor( QColorGroup::Button, QColor( 220, 220, 220) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 253, 253, 253) );
    cg.setColor( QColorGroup::Dark, QColor( 110, 110, 110) );
    cg.setColor( QColorGroup::Mid, QColor( 146, 146, 146) );
    cg.setColor( QColorGroup::Text, QColor( 0, 0, 255) );
    cg.setColor( QColorGroup::BrightText, white );
    cg.setColor( QColorGroup::ButtonText, black );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 255, 255, 169) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setInactive( cg );
    cg.setColor( QColorGroup::Foreground, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Button, QColor( 220, 220, 220) );
    cg.setColor( QColorGroup::Light, white );
    cg.setColor( QColorGroup::Midlight, QColor( 253, 253, 253) );
    cg.setColor( QColorGroup::Dark, QColor( 110, 110, 110) );
    cg.setColor( QColorGroup::Mid, QColor( 146, 146, 146) );
    cg.setColor( QColorGroup::Text, QColor( 0, 0, 255) );
    cg.setColor( QColorGroup::BrightText, white );
    cg.setColor( QColorGroup::ButtonText, QColor( 128, 128, 128) );
    cg.setColor( QColorGroup::Base, white );
    cg.setColor( QColorGroup::Background, QColor( 255, 255, 169) );
    cg.setColor( QColorGroup::Shadow, black );
    cg.setColor( QColorGroup::Highlight, QColor( 0, 0, 128) );
    cg.setColor( QColorGroup::HighlightedText, white );
    pal.setDisabled( cg );
  mainlabel->setPalette( pal );
  mainlabel->setMinimumSize(mainlabel->sizeHint());
  topLayout->addWidget(mainlabel);
  topLayout->addSpacing(7);
  misctab = new MiscTab(this);
  topLayout->addWidget(misctab);

}
