/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: connectbutton.cpp,v 1.4 2000/10/15 19:21:09 davidvh Exp $
// $Log: connectbutton.cpp,v $
// Revision 1.4  2000/10/15 19:21:09  davidvh
// Some small fixes.
//
// Revision 1.3  2000/09/13 19:11:13  napalmbox
// replase kicq ver 1.0.0 files with kicq ver 2.0.0 files
//
// Revision 1.1.2.2  2000/09/02 21:41:13  napalmbox
// fix fix fix ....a big fix
//
// Revision 1.1.2.1  2000/07/02 05:45:55  napalmbox
// port kicq -> kde2 :))
//
// Revision 1.1  2000/05/24 16:59:50  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.7  2000/01/10 16:08:08  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.6  1999/12/02 13:58:49  denis
// Cleanups.
//
// Revision 1.5  1999/07/16 15:47:45  denis
// Cleaned up.
//
// Revision 1.4  1999/07/16 13:01:14  denis
// Internalization support added.
//
// Revision 1.3  1998/12/08 16:09:37  denis
// Cleaned up a little before releasing
//

#include <qpainter.h>
#include <qpixmap.h>

#include "connectbutton.h"
#include "mainwindow.h"

#include "connectbutton.moc"

ConnectButton::ConnectButton(QWidget *parent, const char *name) : QPushButton(parent, name)
{
  timerid = -1;
  setStatus(stOffline);
  return;
}

ConnectButton::~ConnectButton(void)
{
  killTimers();
  return;
}

void ConnectButton::drawButtonLabel(QPainter *p)
{
  p->drawPixmap(6, 3, lpixmap);
  p->drawText(lpixmap.width()+13, 0, width()-13-lpixmap.width(), height(), AlignLeft|AlignVCenter, ltext);
  return;
}

void ConnectButton::setStatus(icqStatus status)
{
  switch(status)
  {
    case stOnline:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = UserIcon("conline");
      ltext = i18n("Online");
      break;
    case stAway:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = UserIcon("caway");
      ltext = i18n("Away");
      break;
    case stDND:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = UserIcon("cdnd");
      ltext = i18n("DND");
      break;
    case stNA:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = UserIcon("cna");
      ltext = i18n("N/A");
      break;
    case stOccupied:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = UserIcon("coccupied");
      ltext = i18n("Occupied");
      break;
    case stFFC:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = UserIcon("cfreechat");
      ltext = i18n("Free Chat");
      break;
    case stInvisible:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = UserIcon("cprivacy");
      ltext = i18n("Privacy");
      break;
    case stOffline:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = UserIcon("coffline");
      ltext = i18n("Offline");
      break;
    case stLogin:
      if(timerid==-1)
      {
        picnum = 1;
        lpixmap = UserIcon("connect1");
        ltext = i18n("Connecting");
        timerid = startTimer(1000);
      }
      break;
  }
  MW->setIcon(lpixmap);
  update();
  return;
}

void ConnectButton::timerEvent(QTimerEvent *te)
{
  QString filename;
  if(te->timerId() == timerid)
  {
    if(picnum == 8)
      picnum = 1;
    else
      picnum++;
    filename.sprintf("connect%i", picnum);
    lpixmap = UserIcon(filename);
    MW->setIcon(lpixmap);
    update(6, 3, lpixmap.width(), lpixmap.height());
  }
  return;
}
