/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: icqanimbutton.cpp,v 1.5 2000/10/15 19:21:10 davidvh Exp $
// $Log: icqanimbutton.cpp,v $
// Revision 1.5  2000/10/15 19:21:10  davidvh
// Some small fixes.
//
// Revision 1.4  2000/09/13 19:11:13  napalmbox
// replase kicq ver 1.0.0 files with kicq ver 2.0.0 files
//
// Revision 1.3.2.1  2000/09/02 22:00:45  napalmbox
// damn big fix :)))
//
// Revision 1.1  2000/07/24 19:05:07  denis
// ICQ button animation was implemented!
//
#include <stdio.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <kapp.h>
#include <kiconloader.h>

#include "icqanimbutton.h"

#include "icqanimbutton.moc"

IcqAnimButton::IcqAnimButton(QWidget *parent, const char *name) : QPushButton(parent, name)
{
  timerid = -1;
  setMouseTracking(TRUE);
  setAnimButtonStatus(stop);
  return;
}

IcqAnimButton::~IcqAnimButton(void)
{
  killTimers();
  return;
}

void IcqAnimButton::drawButtonLabel(QPainter *p)
{
  p->drawPixmap(2, 2, lpixmap);
  return;
}

void IcqAnimButton::setAnimButtonStatus(IcqAnimStatus status)
{
  switch(status)
  {
    case stop:
      if(timerid!=-1)
      {
        killTimer(timerid);
        timerid = -1;
      }
      lpixmap = UserIcon("icq1");
      break;
    case start:
      if(timerid==-1)
      {
        picnum = 1;
        lpixmap = UserIcon("icq1");
        timerid = startTimer(100);
      }
      break;
  }
  update(2, 2, lpixmap.width(), lpixmap.height());
  return;
}

void IcqAnimButton::timerEvent(QTimerEvent *te)
{
  QString filename;
  if(te->timerId()==timerid)
  {
    if(picnum == 17)
      picnum = 17;
    else
      picnum++;
    filename.sprintf("icq%i", picnum);
    lpixmap = UserIcon(filename);
    update(2, 2, lpixmap.width(), lpixmap.height());
  }
  return;
}

void IcqAnimButton::mouseMoveEvent(QMouseEvent *e)
{
  QPushButton::mouseMoveEvent(e);
  if(hitButton(e->pos()))
  {
    setAnimButtonStatus(start);
    grabMouse();
  }
  else
  {
    setAnimButtonStatus(stop);
    releaseMouse();
  }
  return;
}

QSize IcqAnimButton::sizeHint(void) const
{
  return lpixmap.size();
}
