/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
// $Id: icqsound.cpp,v 1.11 2000/10/15 19:21:10 davidvh Exp $
// Revision 1.1.2.2  2000/07/08 16:40:04  napalmbox
// fix ..fix ...
//
// Revision 1.1.2.1  2000/07/02 05:45:55  napalmbox
// port kicq -> kde2 :))
//
// Revision 1.1  2000/05/24 16:59:50  denis
// Sources have been splitted to the whole bunch of appropriate
// directories. Every directory is end up with static library. All
// of them are linked together to the final kicq binary.
//
// Revision 1.6  2000/01/10 16:08:23  denis
// Headers reorganized for simplify dependencies and speedup compilation.
//
// Revision 1.5  1999/12/02 14:22:54  denis
// Cleanups.
//
// Revision 1.4  1999/09/29 17:28:47  denis
// Cleanups.
//
// Revision 1.3  1999/07/16 15:48:03  denis
// Cleaned up.
//

#include <stdio.h>
#include <kapp.h>
#include <kaudioplayer.h>

#include "icqsound.h"
#include "mainwindow.h"
#include "uconfigdb.h"
#include "icqsound.moc"

IcqSound::IcqSound()
{
  eventList.append("Authorization Message");
  eventList.append("Chat Request");
  eventList.append("File Request");
  eventList.append("Startup");
  eventList.append("Incoming Message");
  eventList.append("Incoming URL");
  eventList.append("Online Alert");
  eventList.append("System Message");
  eventList.append("Message Sent");
  eventList.append("File Transfer Done");
  sounds.setAutoDelete(TRUE);
  return;
}

IcqSound::~IcqSound(void)
{
  return;
}
void IcqSound::clear(void)
{
  sounds.clear();
  for(QStrListIterator it(eventList); it.current(); ++it)
    setEvent(it.current(), "");
  return;
}
void IcqSound::play(const QString &soundfile)
{
  if (strcmp(soundfile.latin1(), "(beep)") == 0)
    kapp->beep();
  else
  {
    QString fullsoundfile;

    if(soundfile[0] != '/')
    {
      fullsoundfile = locate("kicq_sounds", "soundfile");

      QFile checkfile(fullsoundfile);
      if(!checkfile.exists())
        fullsoundfile = locate("kicq_sounds", "soundfile");
    }
    else
    {
      fullsoundfile = soundfile;
      KAudioPlayer::play(fullsoundfile);
    }
  }
  return;
}

void IcqSound::soundEvent(const QString &event)
{
  if(MW->playWav)
    if(sounds[event])
      play(sounds[event]);
  return;
}

void IcqSound::savesounds(void)
{
  db->setPath(MW->getOwnerPath() + "/Preferences/Events/Sound/SoundEvents");

  for(QDictIterator<char> it(sounds); it.current(); ++it)
  {
    QString snd = locate("kicq_sounds", it.current());
    db->writeEntry(it.currentKey(), snd);
  }
  return;
}

void IcqSound::loadsounds(void)
{
  db->setPath(MW->getOwnerPath() + "/Preferences/Events/Sound/SoundEvents");

  for(QStrListIterator it(eventList); it.current(); ++it)
  {
    QString str = db->readEntry(it.current()).toString();
    setEvent(it.current(), str);
  }
  return;
}

void IcqSound::setEvent(const QString &event, const QString &str)
{
  sounds.replace(event, strdup(str.local8Bit()));
  return;
}

const QString IcqSound::getEvent(const QString &event)
{
  return sounds[event];
}
