/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _WRAPEDIT_H
#define _WRAPEDIT_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qmlined.h>

class WrapEdit : public QMultiLineEdit
{
  Q_OBJECT
public:
  WrapEdit(QWidget *p = 0, const char *n = 0);
  ~WrapEdit(void);
  void quote(void);
  void setWraping(bool);
  bool isWraping(void);
  void setLimit(unsigned int);
  unsigned int getLimit(void);
  void GotoEnd(void);
protected:
  bool wrap;
  bool needUpdate;
  unsigned int limit;
  void keyPressEvent(QKeyEvent *);
  void resizeEvent(QResizeEvent*);
  void wrapText(int r=-1);
protected slots:
};
#endif /* _WRAPEDIT_H */
