/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _DOCKING_H_
#define _DOCKING_H_

#include <qpixmap.h>
#include <qpoint.h>
#include <kpopupmenu.h>
#include <ksystemtray.h>

class DockWidget : public KSystemTray
{
  Q_OBJECT
public:
  DockWidget(QWidget *parent=0, const char *name=0);
  ~DockWidget(void);
  const int isDocked(void);
  void setIcon(QPixmap);
  void setToolTip(QString);
public slots:
  void dock(void);
  void undock(void);
  void paintIcon(void);
  void hideWindow(void);
  void showWindow(void);
signals:
  void quitClicked(void);
protected:
  int docked;
  int toggleID;
  int doRemove;
  KPopupMenu *dockPopup;
  QPixmap dockIcon;
  int picnum;
  void paintEvent(QPaintEvent*);
protected slots:
  void mousePressEvent(QMouseEvent*);
  void mouseDoubleClickEvent(QMouseEvent*);
  void emitQuit(void);
};
#endif /* _DOCKING_H_ */
